#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <queue>
#include <set>
#include <cmath>

using namespace std;

#define FOR(i,a,b) for(int i = a; i <= b; i++)
#define INF 1000000000

ifstream f("cap.dat");
ofstream g("cap.sol");

int main()
{
	int n, m;
	f >> n >> m;
	vector < vector<char> > a;
	vector < vector <int> > used;
	a.resize(n+2, vector<char>(m+2,'.'));
	used.resize(n+2, vector<int>(m+2, -1));
	pair <int, int> ndd;
	queue < pair<int, int> > q;
	FOR(i,1,n)
		FOR(j,1,m)
		{
			f >> a[i][j];
			if (a[i][j] == '+')
				ndd = make_pair(i,j);
			if (a[i][j] == 'o')
			{
				q.push(make_pair(i,j));
				used[i][j] = 0;
			}
		}
	while (!q.empty())
	{
		pair<int, int> cur = q.front();
		q.pop();
		int x, y;
		x = cur.first + 1;
		while ((a[x][cur.second] == 'x' || a[x][cur.second] == '+') && used[x][cur.second] == -1)
		{
			used[x][cur.second] = used[cur.first][cur.second] + 1;
			q.push(make_pair(x, cur.second));
			x++;
		}
		x = cur.first - 1;
		while ((a[x][cur.second] == 'x' || a[x][cur.second] == '+') && used[x][cur.second] == -1)
		{
			used[x][cur.second] = used[cur.first][cur.second] + 1;
			q.push(make_pair(x, cur.second));
			x--;
		}
		y = cur.second + 1;
		while ((a[cur.first][y] == 'x' || a[cur.first][y] == '+') && used[cur.first][y] == -1)
		{
			used[cur.first][y] = used[cur.first][cur.second] + 1;
			q.push(make_pair(cur.first, y));
			y++;
		}
		y = cur.second - 1;
		while ((a[cur.first][y] == 'x' || a[cur.first][y] == '+') && used[cur.first][y] == -1)
		{
			used[cur.first][y] = used[cur.first][cur.second] + 1;
			q.push(make_pair(cur.first, y));
			y--;
		}
	}
	g << used[ndd.first][ndd.second];
	f.close();
	g.close();
	return 0;
}