#pragma comment ( linker, "/STACK:8666685")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <algorithm>
#include <memory.h>
using namespace std;

struct sList
{
	int v;
	unsigned long int d;
	int next;
};

struct sVertexes
{
	int v;
	unsigned long int d;
};
sVertexes vertexes[ 1000005 ]; int K = 0;

int head[ 2000005 ] = { 0 };
sList list[ 2000005 ];
int k = 0;

void AddEdge( int a, int b, unsigned long int d )
{
	if( a == b )
		return;
	k++;
	list[k].v = b;
	list[k].d = d;
	list[k].next = head[a];
	head[a] = k;
}

int main()
{
	FILE *inf = fopen( "olympair.dat", "r" );
	FILE *outf = fopen( "olympair.sol", "w" );

	int N, M;

	fscanf( inf, "%d %d", &N, &M );

	for( int i = 1; i <= M; i++ )
	{
		unsigned long int T, A, B;
		int C;
		fscanf( inf, "%ld %ld %ld %d", &T, &A, &B, &C );
		if( T == 1 )
		{
			AddEdge( A, B, C );
		}
		else
		{
			int currentEdge = head[ A ];
			K = 0;
			while( currentEdge )
			{
				K++;
				vertexes[K].v = list[ currentEdge ].v;
				unsigned long int temp;
				if( C > 0 )
					temp = list[ currentEdge ].d + ( unsigned long int )( C );
				else
					temp = list[ currentEdge ].d - ( unsigned long int )( -C );
				vertexes[K].d = temp;
				currentEdge = list[ currentEdge ].next;
			}
			for( int j = 1; j <= K; j++ )
				AddEdge( B, vertexes[j].v, vertexes[j].d );
		}
	}

	unsigned long int dist[ 100005 ];
	bool used[ 100005 ] = { false };
	memset( dist, 63, sizeof( dist ) );
	unsigned long int INF = dist[0];
	dist[1] = 0;

	while( true )
	{
		int currentVertex = 0;
		bool finish = true;
		for( int i = 1; i <= N; i++ )
		{
			if( !used[i] && dist[i] < dist[currentVertex] )
			{
				finish = false;
				currentVertex = i;
			}
		}
		if( finish )
			break;
		used[ currentVertex ] = true;
		int currentEdge = head[currentVertex];
		while( currentEdge )
		{
			if( list[ currentEdge ].d + dist[ currentVertex ] <
				dist[ list[ currentEdge ].v ] )
				dist[ list[ currentEdge ].v ] = list[ currentEdge ].d + dist[ currentVertex ];
			currentEdge = list[ currentEdge ].next;
		}
	}

	for( int i = 2; i <= N; i++ )
	{
		if( dist[i] == INF )
			fprintf( outf, "-1\n" );
		else
			fprintf( outf, "%ld\n", dist[i] );
	}

	fclose( inf );
	fclose( outf );
}
