#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cmath>
#include <set>
#include <map>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 100000;

int a[MaxN];
int f[MaxN];

bool used[MaxN];

vector<int> wh[MaxN];

int n;

void add(int x) {
	int now = x;
	while (now < n) {
		f[now]++;
		now = now | (now+1);
	}
}

int sum (int n) {
	if (n == -1) return 0;
	int res = 0;
	for (n; n >= 0; n = (n & (n+1))-1)
		res += f[n];
	return res;
}

int sum (int l, int r) {
	return sum(r) - sum(l-1);
}

int main () {
	freopen ("mutation.dat", "r", stdin);
	freopen ("mutation.sol", "w", stdout);
	int x;
	cin >> n;
	for (int i = 0; i < n; i++) {
		f[i] = 0;
		used[i] = false;
	}
	for (int i = 0; i < n; i++) {
		scanf ("%d", &x);
		x--;
		a[i]=x;
		wh[x].push_back(i);
	}
	int i = 0;
	int result = 0;
	while (i < n) {
		while (i < n && used[i]) i++;
		if (i >= n) break;
		int elem = a[i];
		int lastElem = wh[elem].back();
		int sz = (int)wh[elem].size();
		int Sum = sum(i, lastElem);
		if (sz != lastElem-i+1-Sum) result++;
		for (int j = 0; j < sz; j++) {
			used[wh[elem][j]] = true;
			add(wh[elem][j]);
		}
	}
	cout << result;
}