#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cmath>
#include <set>
#include <map>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 100000;

const int inf = 1000000000;

vector<vector<pair<int, int> > > g;

map<pair<int, int>, int> Map;
map<pair<int, int>, bool> is;

int d[MaxN];

int main () {
	freopen ("olympair.dat", "r", stdin);
	freopen ("olympair.sol", "w", stdout);
	int n, m;
	scanf ("%d%d", &n, &m);
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int t, a, b, c;
		scanf ("%d%d%d%d", &t, &a, &b, &c);
		a--;
		b--;
		if (t == 1) {
			pair<int, int> q = make_pair(a, b);
			if (is[q])
				Map[q] = min(Map[q], c);
			else {
				is[q] = true;
				Map[q] = c;
			}
			g[a].push_back(make_pair(b, c));
		} else {
			for (int j = 0; j < g[a].size(); j++) {
				int to = g[a][j].first;
				int w = g[a][j].second;
				if (Map[make_pair(a, to)] != w) {
					g[a].erase(g[a].begin()+j);
					j--;
					continue;
				}
				pair<int, int> q = make_pair(b, to);
				if (is[q])
					Map[q] = min(Map[q], w+c);
				else {
					Map[q] = w+c;
					is[q] = true;
				}
				g[b].push_back(make_pair(to, w+c));
			}
		}
	}
	for (int i = 1; i < n; i++)
		d[i] = inf;
	d[0] = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			for (int k = 0; k < (int)g[j].size(); k++) {
				int to = g[j][k].first;
				int w = g[j][k].second;
				if (d[j] != inf) 
					d[to] = min(d[to], d[j]+w);
			}
	for (int i = 1; i < n; i++) {
		if (d[i] == inf) d[i] = -1;
		printf("%d\n", d[i]);
	}
}