#include <iostream>
#include <cstdio>
#include <algorithm>
#include <vector>
#include <cstdlib>
#include <cmath>
#include <set>
#include <map>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 2000;

const long long inf = 1000000000000000000;

vector<vector<int> > g;

long long W[MaxN][MaxN];

map<pair<int, int>, long long> Map;
map<pair<int, int>, bool> is;

long long d[MaxN];

int main () {
	freopen ("olympair.dat", "r", stdin);
	freopen ("olympair.sol", "w", stdout);
	int n, m;
	scanf ("%d%d", &n, &m);
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			W[i][j] = inf;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int t, a, b, c;
		scanf ("%d%d%d%d", &t, &a, &b, &c);
		a--;
		b--;
		if (t == 1) {
			pair<int, int> q = make_pair(a, b);
			if (W[a][b] != inf)
				W[a][b] = min(W[a][b], c);
			else {
				W[a][b] = c;
				g[a].push_back(b);
			}
		} else {
			for (int j = 0; j < (int)g[a].size(); j++) {
				int to = g[a][j];
				int w = W[a][to];
				pair<int, int> q = make_pair(b, to);
				if (W[b][to] != inf)
					W[b][to] = min(W[b][to], w+c);
				else {
					W[b][to] = w+c;
					g[b].push_back(to);
				}
			}
		}
	}
	for (int i = 1; i < n; i++)
		d[i] = inf;
	d[0] = 0;
	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			for (int k = 0; k < (int)g[j].size(); k++) {
				int to = g[j][k];
				long long w = W[j][to];
				if (d[j] != inf) 
					d[to] = min(d[to], d[j]+w);
			}
	for (int i = 1; i < n; i++) {
		if (d[i] == inf) d[i] = -1;
		printf("%d\n", d[i]);
	}
}