#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <string>

#define min(a, b) (((a) > (b)) ? (b) : (a))
#define max(a, b) (((a) > (b)) ? (a) : (b))

using namespace std;

const int MaxN = 1000;
const int MaxM = 1000;

struct circle {
	long long x, y, r, c;
	long long people;
};

struct man {
	long long x, y, l;
};

circle a[MaxN+1];
man    b[MaxM];

vector<vector<long long> > g;

bool comp(circle one, circle two) {
	return one.r < two.r;
}

long long result = 1000000000000;
bool used[MaxN+1];
long long  dist[MaxN+1];

int n, k;
long long q[MaxN+1];

long long numP[MaxN+1];

long long allP = 0;

long long son[MaxN+1];

long long updAns[MaxN+1];

bool usedNEW[MaxN+1];

/*void getP (int v) {
	int all = 0;
	usedNEW[v] = true;
	for (int i = 0; i < (int)g[v].size(); i++) {
		int to = g[v][i];
		if (!usedNEW[to]) {
			getP (to);
			all += numP[to];
		}
	}
	if (all != 0) 
		numP[v] = all;
	else
		numP[v] = a[v].people;
} */

void bfs (int v) {
	for (int i = 0; i <= n; i++)
		used[i] = false;
	int l=0, r=1;
	q[l] = v;
	dist[v] = 0;
	used[v] = true;
	while (l < r) {
		int now = q[l], d = dist[now];
		for (int i = 0; i < (int)g[now].size(); i++) {
			int to = g[now][i];
			if (!used[to]) {
				used[to] = true;
				dist[to] = d+a[now].c+a[to].c;
				q[r] = to;
				r++;
			}
		}
		l++;
	}
	for (int i = 0; i <= n; i++)
		used[i] = false;
	int nSon = 0;
	int q = 0;
	for (int i = 0; i <= n; i++) {
		if (i == v) continue;
		if ((a[i].x - a[v].x) * (a[i].x - a[v].x) + (a[i].y - a[v].y) * (a[i].y - a[v].y) <= a[v].r*a[v].r)
			son[nSon++] = i;
	}
	for (int i = 0; i < nSon; i++) {
		int to;
		int from = son[i];
		used[from] = true;
		for (int j = 0; j < (int)g[from].size(); j++)
			if (dist[from] > dist[g[from][j]]) {
				to = g[from][j];
				break;
			}
		updAns[q++] = (a[from].c + a[to].c)*a[to].people;
	}
	for (int i = 0; i <= n; i++)
		if (!used[i]) {
			if (v == i) continue;
			int from = i;
			int to;
			for (int j = 0; j < (int)g[from].size(); j++)
				if (dist[from] > dist[g[from][j]]) {
					to = g[from][j];
					break;
				}
			updAns[q++] = (a[from].c + a[to].c)*(allP - a[from].people);
		}
	sort(updAns, updAns+q);
	int mbRes = 0;
	for (int i = 0; i < q-k; i++)
		mbRes += updAns[i];
	result = min(result, mbRes);
}

int main () {
	freopen ("camelot.dat", "r", stdin);
	freopen ("camelot.sol", "w", stdout);
	int m;
	scanf ("%d%d%d", &n, &m, &k);
	g.resize(n+1);
	a[n].x = 0;
	a[n].y = 0;
	a[n].r = 100000000;
	a[n].people = 0;
	for (int i = 0; i < n; i++) {
		scanf ("%d%d%d%d", &a[i].x, &a[i].y, &a[i].r, &a[i].c);
		a[i].people = 0;
	}
	for (int i = 0; i < m; i++) {
		scanf ("%d%d%d", &b[i].x, &b[i].y, &b[i].l);
		allP += b[i].l;
	}
	sort(a, a+n+1, comp);
	for (int i = 0; i < m; i++)
		for (int j = 0; j <= n; j++) 
			if ((b[i].x - a[j].x)*(b[i].x - a[j].x) + (b[i].y - a[j].y)*(b[i].y - a[j].y) <= a[j].r*a[j].r)
				a[j].people += b[i].l;
	for (int i = 0; i < n; i++)
		for (int j = i+1; j <= n; j++)
			if ((a[i].x - a[j].x) * (a[i].x - a[j].x) + (a[i].y - a[j].y) * (a[i].y - a[j].y) <= a[j].r*a[j].r) {
				g[i].push_back(j);
				g[j].push_back(i);
				break;
			}
/*	for (int i = 0; i <= n; i++)
		usedNEW[i] = false;
	getP(n); */
	for (int i = 0; i <= n; i++)
		bfs(i);
	cout << result; 
}