#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <string>
#include <map>
#include <list>
#include <set>
#include <queue>
#include <bitset>

using namespace std;

#define problem "mutation"

const int MAX_N = (int) 1e5;
const long long inf = 9223372036854775807LL;

typedef vector<int>::iterator itr;

int n, res = 0;
vector<int> a;
itr iter;
map<int, pair<itr, int> > bg;
bitset<MAX_N> exist;
set< pair<int, int> > dist;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    cin >> n;
    a.reserve(n);

    for (int i = 0, cur; i < n; ++i) {
        cin >> a[i];
        exist[a[i]] = true;
    }

    for (int i = 0; i < n; ++i) {
        if (bg.count(a[i])) {
            if (i - bg[a[i]].second > 1)
                dist.insert(make_pair(i - bg[a[i]].second + 1, a[i]));
        } else {
            bg[a[i]] = make_pair(a.begin() + i - 1, i);
        }
    }

    pair<int, int> pr; bool ne;
    while (!dist.empty()) {
        pr = *dist.rbegin();
        dist.erase(pr);

        if (exist[pr.second]) {
            ne = true;
            for (iter = (bg[pr.second].first + 1); ne && iter != a.end(); ++iter) {
                if (exist[*iter]) {
                    ne = false;
                }
            }

            if (!ne) {
                exist[pr.second] = false;
                ++res;
            }
        }
    }

    cout << res;

    return 0;
}
