#include <iostream>
#include <cstdio>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define problem "olympair"

const int MAX_N = (int) 1e5;
const long long inf = (long long) 1e12;

int n, m;
vector< pair<int, long long> > edge[MAX_N];
vector<long long> path;

void find_min_path() {
    path.resize(n, inf);
    path[0] = 0;

    set< pair<long long, int> > dist;
    for (int i = 0; i < n; ++i) {
        dist.insert(make_pair(path[i], i));
    }

    int vertex;
    long long pth, trg, trg_p;
    while (!dist.empty()) {
        vertex = (*dist.begin()).second;
        pth = path[vertex];

        dist.erase(make_pair(pth, vertex));

        for (int j = 0; j < edge[vertex].size(); ++j) {
            trg = edge[vertex][j].first;
            trg_p = edge[vertex][j].second;
            if (path[trg] > (pth + trg_p)) {
                dist.erase(make_pair(path[trg], trg));
                dist.insert(make_pair(pth + trg_p, trg));
                path[trg] = pth + trg_p;
            }
        }
    }
}

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);

    for (int i = 0, type, a, b, c; i < m; ++i) {
        scanf("%d %d %d %d\n", &type, &a, &b, &c);
        --a;
        --b;

        if (type == 1) {
            if (a != b)
                edge[a].push_back(make_pair(b, c));
        } else {
            for (int j = 0; j < edge[a].size(); ++j) {
                if (edge[a][j].first != b)
                    edge[b].push_back(make_pair(edge[a][j].first, edge[a][j].second + c));
            }
        }
    }

    find_min_path();

    for (int i = 1; i < n; ++i) {
        printf("%d\n", (path[i] != inf) ? path[i] : -1);
    }

    return 0;
}
