#include <iostream>
#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <map>
#include <set>

using namespace std;

#define problem "olympair"

const int MAX_N = (int) 1e5;
const long long inf = 9223372036854775807LL;

int n, m;
map<int, long long> edge[MAX_N];
map<int, long long>::iterator iter;
long long path[MAX_N];

void find_min_path() {
    fill_n(path, n, inf);
    path[0] = 0;

    set< pair<long long, int> > dist;

    dist.insert(make_pair(0, 0));

    int vertex, trg;
    long long pth, trg_p;
    while (!dist.empty()) {
        vertex = (*dist.begin()).second;
        pth = path[vertex];

        dist.erase(make_pair(pth, vertex));

        for (iter = edge[vertex].begin(); iter != edge[vertex].end(); ++iter) {
            trg = iter->first;
            trg_p = iter->second;
            if (path[trg] > (pth + trg_p)) {
                dist.erase(make_pair(path[trg], trg));
                dist.insert(make_pair(pth + trg_p, trg));
                path[trg] = pth + trg_p;
            }
        }
    }
}

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);

    long long c;
    for (int i = 0, type, a, b; i < m; ++i) {
        scanf("%d %d %d %lld\n", &type, &a, &b, &c);
        --a;
        --b;

        if (type == 1) {
            if (a != b) {
                if (edge[a].count(b))
                    edge[a][b] = min(edge[a][b], c);
                else
                    edge[a][b] = c;
            }
        } else {
            for (iter = edge[a].begin(); iter != edge[a].end(); ++iter) {
                if ((iter->first) != b) {}
                    if (edge[b].count(iter->first))
                        edge[b][(iter->first)] = min(edge[b][(iter->first)], (iter->second) + c);
                    else
                        edge[b][(iter->first)] = (iter->second) + c;

                if (edge[b][(iter->first)] <= 0) {
                    cout << "56";
                    exit(0);
                }
            }
        }
    }

    find_min_path();

    for (int i = 1; i < n; ++i) {
        printf("%lld\n", (path[i] != inf) ? path[i] : -1);
    }

    return 0;
}
