#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "cap"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, m, st_r, st_c, en_r, en_c;
vector<int> step[MAX_N];
list<int> rows[MAX_N], cols[MAX_N];
list<int>::iterator iter;
queue< pair<int, int> > pos;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);

    for (int i = 0; i < n; ++i)
        step[i].resize(m, inf);

    char ch;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            scanf("%c", &ch);
            switch (ch) {
                case 'x': {
                    rows[i].push_back(j);
                    cols[j].push_back(i);
                } break;
                case 'o': {
                    st_r = i;
                    st_c = j;
                } break;
                case '+': {
                    en_r = i;
                    en_c = j;
                    rows[i].push_back(j);
                    cols[j].push_back(i);
                } break;
            }
        }
        scanf("\n");
    }

    pos.push(make_pair(st_r, st_c));
    step[st_r][st_c] = 0;

    pair<int, int> pr; int row, col;
    while (!pos.empty()) {
        pr = pos.front();
        row = pr.first;
        col = pr.second;
        pos.pop();

        //cout << '!' << row << ' ' << col << endl;

        if (row == en_r && col == en_c) {
            printf("%d", step[row][col]);
            exit(0);
        }

        for (iter = rows[row].begin(); iter != rows[row].end(); ++iter) {
            if (step[row][*iter] > (step[row][col] + 1)) {
                pos.push(make_pair(row, (*iter)));
                step[row][*iter] = step[row][col] + 1;
            }
        }
        rows[row].clear();

        for (iter = cols[col].begin(); iter != cols[col].end(); ++iter) {
           if (step[*iter][col] > (step[row][col] + 1)) {
                pos.push(make_pair((*iter), col));
                step[*iter][col] = step[row][col] + 1;
            }
        }
        cols[col].clear();
    }

    printf("-1");

    return 0;
}
