#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "cap"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, m, st_r, st_c, en_r, en_c;
list<int> rows[MAX_N], cols[MAX_N];
list<int>::iterator iter;
list<int>::reverse_iterator riter;
queue< pair< pair<int, int>, int> > pos;

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);

    char ch;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            scanf("%c", &ch);
            if (ch == 'x') {
                rows[i].push_back(j);
                cols[j].push_back(i);
            } else
            if (ch == 'o') {
                st_r = i;
                st_c = j;
            } else
            if (ch == '+') {
                en_r = i;
                en_c = j;
                rows[i].push_back(j);
                cols[j].push_back(i);
            }
        }
        scanf("\n");
    }

    pos.push(make_pair(make_pair(st_r, st_c), 0));

    pair< pair<int, int>, int> pr; int row, col, step;
    while (!pos.empty()) {
        pr = pos.front();
        row = pr.first.first;
        col = pr.first.second;
        step = pr.second + 1;
        pos.pop();

        //cout << '!' << row << ' ' << col << endl;

        if (row == en_r && col == en_c) {
            printf("%d", step - 1);
            exit(0);
        }

        if (row == en_r || col == en_c) {
            printf("%d", step);
            exit(0);
        }

        if (col > en_c) {
            for (iter = rows[row].begin(); iter != rows[row].end(); ++iter) {
                pos.push(make_pair(make_pair(row, (*iter)), step));
            }
        } else {
            for (riter = rows[row].rbegin(); riter != rows[row].rend(); ++riter) {
                pos.push(make_pair(make_pair(row, (*riter)), step));
            }
        }

        rows[row].clear();

        if (row > en_r) {
            for (iter = cols[col].begin(); iter != cols[col].end(); ++iter) {
                pos.push(make_pair(make_pair((*iter), col), step));
            }
        } else {
            for (riter = cols[col].rbegin(); riter != cols[col].rend(); ++riter) {
                pos.push(make_pair(make_pair((*riter), col), step));
            }
        }

        cols[col].clear();
    }

    printf("-1");

    return 0;
}
