#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>

using namespace std;

#define problem "cap"

const int MAX_N = (int) 1e3;
const int inf = (int) 1e8;

int n, m, st_r, st_c, en_r, en_c, cr;
queue<int> rows[MAX_N], cols[MAX_N];

void dfs(int row, int col, int step) {
    if (row == en_r && col == en_c) {
        printf("%d", step);
        exit(0);
    }

    if (row == en_r || col == en_c) {
        printf("%d", step + 1);
        exit(0);
    }

    while(!rows[row].empty()) {
        cr = rows[row].front();
        rows[row].pop();
        dfs(row, cr, step + 1);
    }

    while (!cols[col].empty()) {
        cr = cols[col].front();
        cols[col].pop();
        dfs(cr, col, step + 1);
    }
}

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d\n", &n, &m);

    char ch;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            scanf("%c", &ch);
            if (ch == 'x') {
                rows[i].push(j);
                cols[j].push(i);
            } else
            if (ch == 'o') {
                st_r = i;
                st_c = j;
            } else
            if (ch == '+') {
                en_r = i;
                en_c = j;
                rows[i].push(j);
                cols[j].push(i);
            }
        }
        scanf("\n");
    }

    dfs(st_r, st_c, 0);

    printf("-1");

    return 0;
}
