#include <cstdio>
#include <iostream>
#include <cstring>
#include <cstdlib>
#include <vector>
#include <queue>
#include <deque>
#include <list>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>

using namespace std;

#define problem "camelot"

typedef set<int>::iterator itr;

const int MAX_N = 35001;
const long long inf = (long long) 1e18;

int n, m, k, i, j, x, y, l;
int fort_x[MAX_N], fort_y[MAX_N], fort_r[MAX_N], fort_c[MAX_N], knight[MAX_N];
set<int> fort_inl[MAX_N], knight_inl[MAX_N];
map<int, long long> bst;
map<int, long long>::iterator bsti;
vector<long long> ch;
itr iter;

inline long double dist(const long long x1, const long long y1, const long long x2, const long long y2) {
    return sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
}

int main() {
    freopen(problem ".dat", "r", stdin);
    freopen(problem ".sol", "w", stdout);

    scanf("%d %d %d\n", &n, &m, &k);

    for (i = 0; i < n; ++i) {
        scanf("%d %d %d %d\n", &fort_x[i], &fort_y[i], &fort_r[i], &fort_c[i]);
    }

    ++n;
    fort_x[n - 1] = 0;
    fort_y[n - 1] = 0;
    fort_c[n - 1] = 0;
    fort_r[n - 1] = inf;

    for (i = 0; i < n; ++i) {
        for (j = 0; j < n; ++j) {
            if (i != j && dist(fort_x[i], fort_y[i], fort_x[j], fort_y[j]) <= fort_r[i]) {
                fort_inl[j].insert(i);
            }
        }
    }

    for (i = 0; i < m; ++i) {
        scanf("%d %d %d\n", &x, &y, &l);

        knight[i] = l;

        for (j = 0; j < n; ++j) {
            if (dist(x, y, fort_x[j], fort_y[j]) <= fort_r[j])
                knight_inl[i].insert(j);
        }
    }

    //fort_c[2] = 0;

    long long res = inf, path;
    for (i = 0; i < n; ++i) {
        path = 0;
        //cout << endl;
        for (j = 0; j < m; ++j) {
            for (iter = knight_inl[j].begin(); iter != knight_inl[j].end(); ++iter) {
                if ((*iter != i) && !fort_inl[i].count(*iter)) {
                    path += knight[j] * fort_c[*iter];
                    bst[*iter] += knight[j] * fort_c[*iter];
                    //cout << "   HO" << (*iter) << ' ' << j << endl;
                }
            }

            if (!knight_inl[j].count(i)) {
                path += knight[j] * fort_c[i];
                bst[i] += knight[j] * fort_c[i];
                //cout << "   HC" << j << endl;
            }

            for (iter = fort_inl[i].begin(); iter != fort_inl[i].end(); ++iter) {
                if ((*iter != i) && !knight_inl[j].count(*iter)) {
                    path += knight[j] * fort_c[*iter];
                    bst[*iter] += knight[j] * fort_c[*iter];
                    //cout << "   HOK" << (*iter) << ' ' << j << endl;
                }
            }
        }

        for (bsti = bst.begin(); bsti != bst.end(); ++bsti) {
            ch.push_back(bsti->second);
        }

        sort(ch.rbegin(), ch.rend());

        for (int g = 0; g < k; ++g) {
            path -= ch[g];
        }

        ch.clear();
        bst.clear();

        //cout << i << ' ' << path << endl;

        res = min(res, path);

        if (res < n*m/2) break;
    }


    cout << res;

    return 0;
}
