#include <iostream>
#include <stdio.h>
#include <vector>

using namespace std;

typedef long long int ll;

const int Max = 100010;
const int Max2 = 140000;

const ll Inf = 1234567890123456;

struct TRec {
    ll v;
    int a;
};

TRec tr[Max2] = {{0}};

int Full(int n) {
    bool full = true;
    int c = 0;

    while (n > 1) {
        ++c;

        if (n % 2 == 1) {
            full = false;
        }
        n /= 2;
    }

    if (!full) {
        ++c;
    }

    return (1 << c);
}

int Up(int a) {
    return (a - 1) / 2;
}

int Left(int a) {
    return (a * 2 + 1);
}

int Right(int a) {
    return (a * 2 + 2);
}

void Set(TRec* tr, int nf, int a, ll v) {
    int i = a + nf - 1;

    tr[i].a = a;
    tr[i].v = v;

    while (i > 0) {
        int up = Up(i);
        int l = Left(up);
        int r = l + 1;

        if (tr[l].v <= tr[r].v) {
            tr[up] = tr[l];
        } else {
            tr[up] = tr[r];
        }

        i = Up(i);
    }
}

struct TVertex {
    int to;
    int p;
};

int main() {
    FILE* f = fopen("olympair.dat", "r");

    int n;
    int m;
    fscanf(f, "%d%d", &n, &m);

    vector< vector<TVertex> > edges(n);

    for (int i = 0; i < m; ++i) {
        int cmd;

        int a;
        int b;
        int c;

        fscanf(f, "%d%d%d%d", &cmd, &a, &b, &c);
        --a;
        --b;

        if (cmd == 1) {
            TVertex rec;
            rec.to = b;
            rec.p = c;

            edges[a].push_back(rec);
        }
    }

    fclose(f);


    int nf = Full(n);

    for (int i = 0; i < n; ++i) {
        tr[i + nf - 1].a = i;
    }

    for (int i = 0; i < 2 * nf; ++i) {
        tr[i].v = Inf + 2;
    }

    Set(tr, nf, 0, 0);
    for (int i = 1; i < n; ++i) {
        Set(tr, nf, i, Inf);
    }

    ll res[Max];
    for (int i = 0; i < n; ++i) {
        res[i] = -1;
    }

    while (tr[0].v < Inf) {
        int a = tr[0].a;
        ll cur = tr[0].v;

        res[a] = cur;

        Set(tr, nf, a, Inf + 1);

        for (int i = 0; i < (int)edges[a].size(); ++i) {
            int b = edges[a][i].to;
            ll v = edges[a][i].p;

            if (cur + v < tr[b + nf - 1].v) {
                Set(tr, nf, b, cur + v);
            }
        }
    }

    f = fopen("olympair.sol", "w");

    for (int i = 1; i < n; ++i) {
        fprintf(f, "%I64d\n", res[i]);
    }

    fclose(f);

    return 0;
}
