#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <set>
#include <cstdio>
#include <map>
#include <deque>

#pragma comment (linker, "/stack:200000000")
#define abs(a) ((a < 0) ? (-(a)) : (a))
#define min(a, b) ((a < b) ? (a) : (b))
#define max(a, b) ((a > b) ? (a) : (b))
#define forn(i, a, b) for (int i = (a); i < (b); i++)
#define mp make_pair
using namespace std;

struct pt
{
	short x, y;
};

bool cw(pt a, pt b, pt c)
{
	return a.x * (b.y - c.y) - b.x * (a.y - c.y) + c.x * (a.y - b.y) < 0;
}

bool ccw(pt a, pt b, pt c)
{
	return a.x * (b.y - c.y) - b.x * (a.y - c.y) + c.x * (a.y - b.y) > 0;
}
const int MAXN = 1001;
pt null = {MAXN - 1, MAXN - 1};
const short INF = 30000;
	int n, m;
	char a[MAXN];
	bool p[MAXN][MAXN];
	short dp[MAXN][MAXN][2];
	pt nxt[MAXN][MAXN][4];
bool used[MAXN][MAXN][2];

int main()
{
	freopen("cap.dat", "r", stdin);	freopen("cap.sol", "w", stdout);


	for (int i = 0; i < 1001; i++)
		for (int j = 0; j < 1001; j++)
			used[i][j][0] = used[i][j][1] = 0;
	scanf("%d%d", &n, &m);
	pt st, fin;
	for (int i = 0; i < n; i++)
	{
		scanf("%s", a);
		for (int j = 0; j < m; j++)
			if (a[j] == 'o')
				st.x = i, st.y = j, p[i][j] = 1;
			else if (a[j] == '+')
				fin.x = i, fin.y = j, p[i][j] = 1;
			else if (a[j] == 'x')
				p[i][j] = 1;
			else
				p[i][j] = 0;
	}

	
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			nxt[i][j][0] = nxt[i][j][1] = nxt[i][j][2] = nxt[i][j][3] = null;
	deque< pair<pt, bool > > bfs;
	for (int i = 0; i < n; i++)
	{
		pt last = null;
		for (int j = 0; j < m; j++)
			if (p[i][j])
			{
				pt cur = {i, j};
				nxt[last.x][last.y][1] = cur;
				nxt[cur.x][cur.y][3] = last;
				last = cur;
			}
	}
	for (int j = 0; j < m; j++)
	{
		pt last = null;
		for (int i = 0; i < n; i++)
			if (p[i][j])
			{
				pt cur = {i, j};
				nxt[last.x][last.y][2] = cur;
				nxt[cur.x][cur.y][0] = last;
				last = cur;
			}
	}
	bfs.push_back(mp(st, 0));
	bfs.push_back(mp(st, 1));
	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			dp[i][j][0] = dp[i][j][1] = INF;
	dp[st.x][st.y][0] = dp[st.x][st.y][1] = 1;
	dp[null.x][null.y][0] = dp[null.x][null.y][1] = 30100;
	used[1000][1000][0] = used[1000][1000][1] = 1;
	while (!bfs.empty())
	{
		pair<pt, bool > cur = bfs.front(); 
		bfs.pop_front();
		int dst = dp[cur.first.x][cur.first.y][cur.second];
		if (used[fin.x][fin.y][0] && used[fin.x][fin.y][1])
			break;
		if (used[cur.first.x][cur.first.y][cur.second])
			continue;
		pt next = nxt[cur.first.x][cur.first.y][1],
				prev = nxt[cur.first.x][cur.first.y][3],
				top = nxt[cur.first.x][cur.first.y][0],
				bot = nxt[cur.first.x][cur.first.y][2];
		if (cur.second)
		{
			if (!used[next.x][next.y][1] && dp[next.x][next.y][1] > dst)
			{
				dp[next.x][next.y][1] = dst;
				bfs.push_front(mp(next, 1));
			}
			if (!used[prev.x][prev.y][1] && dp[prev.x][prev.y][1] > dst)
			{
				dp[prev.x][prev.y][1] = dst;
				bfs.push_front(mp(prev, 1));
			}

			if (!used[top.x][top.y][0] && dp[top.x][top.y][0] > dst + 1)
				dp[top.x][top.y][0] = dst + 1, 
				bfs.push_back(mp(top, 0));
			if (!used[bot.x][bot.y][0] && dp[bot.x][bot.y][0] > dst + 1)
				dp[bot.x][bot.y][0] = dst + 1,
				bfs.push_back(mp(bot, 0));
		}
		else
		{
			if (!used[next.x][next.y][1] && dp[next.x][next.y][1] > dst + 1)
				dp[next.x][next.y][1] = dst + 1,
				bfs.push_back(mp(next, 1));
			if (!used[prev.x][prev.y][1] && dp[prev.x][prev.y][1] > dst + 1)
				dp[prev.x][prev.y][1] = dst + 1,
				bfs.push_back(mp(prev, 1));

			if (!used[top.x][top.y][0] && dp[top.x][top.y][0] > dst)
			{
				bfs.push_front(mp(top, 0));
				dp[top.x][top.y][0] = dst;
			}
			if (!used[bot.x][bot.y][0] && dp[bot.x][bot.y][0] > dst)
			{
				bfs.push_front(mp(bot,0));
				dp[bot.x][bot.y][0] = dst;
			}
		}
		used[cur.first.x][cur.first.y][cur.second] = 1;
	}
	int res = min(dp[fin.x][fin.y][0], dp[fin.x][fin.y][1]);
	if (res == INF)
		cout << -1 << endl;
	else
		cout << res << endl;
}