#include <iostream>
#include <vector>

using namespace std;

int n, m, k;
typedef long long ll;
struct circle
{
	circle() { }
	circle(int x, int y) : x(x), y(y), r(0), pr(0) { }
	ll x, y, r, pr;
} A[1002];

double dst(circle f, circle s)
{
	return sqrt(double (f.x - s.x) * (f.x - s.x) + (f.y -s.y) * (f.y - s.y));
}

bool in(circle f, circle s)
{
	if (dst(f, s) >= f.r + s.r)
		return false;
	if (f.r < s.r)
		return true;
	return false;
}


vector<int> g[1002];
int cnt[1002];
int p[1002];
pair<int, ll> wt[1002];

void dfs(int v = 0)
{
	for (int i = 0; i < g[v].size(); i++)
	{
		int to = g[v][i];
		dfs(to);
		wt[v].first += wt[to].first + wt[to].second * A[to].pr;
		wt[v].second += wt[to].second;
	}
	wt[v].second += cnt[v];
}
ll getSum(int v)
{
	ll result = wt[v].first;
	ll add = A[v].pr;
	int curV = p[v];
	int chil = v;
	while (curV != -1)
	{
		int r = 0;
		for (int i = 0; i < g[curV].size(); i++)
		{
			int to = g[curV][i];
			if (to == chil)
				continue;
			r += wt[to].first + wt[to].second * (A[to].pr + add);
		}
		result += r;
		chil = curV;
		add += A[curV].pr;
		curV = p[curV];
	}
	return result;
}
int main()
{
	freopen("camelot.dat", "r", stdin);
	freopen("camelot.sol", "w", stdout);
	p[0] = -1;
	scanf("%d%d%d", &n, &m, &k);
	A[0].x = 0, A[0].y = 0, A[0].r = 100000000, A[0].pr = 0;
	for (int i = 1; i <= n; i++)
		cin >> A[i].x >> A[i].y >> A[i].r >> A[i].pr;
	n++;
	for (int i = 0; i < 1001; i++)
		cnt[i] = 0;
	for (int i = 0; i < m; i++)
	{
		int x, y, cc;
		cin >> x >> y >> cc;
		int cur = 0;
		for (int j = 1; j < n; j++)
			if (in(circle(x, y), A[j]) && A[j].r < A[cur].r)
				cur = j;
		cnt[cur] += cc;
	}
	
	for (int i = 1; i < n; i++)
	{
		int cur = 0;
		for (int j = 1; j < n; j++)
			if (in(A[i], A[j]) && A[j].r < A[cur].r)
				cur = j;
		p[i] = cur;
		g[cur].push_back(i);
	}
	p[0] = -1;
	ll res = 200000000000000ll;
	dfs();
	for (int i = 0; i < n; i++)
	{
		ll num = getSum(i);
		res = min(res, num);
	}
	cout << res << endl;
}