#include <iostream>
#include <fstream>
#include <vector>
#include <map>
#include <set>
using namespace std;

struct pp{
	int wh;
	long long di;
	pp() {}
	pp(int wh, long long di) : wh(wh), di(di) {}
	friend bool operator <(pp a, pp b)
	{
		return a.di < b.di;
	}
	friend bool operator == (pp a, pp b)
	{
		return (a.di == b.di) && (a.wh == b.wh);
	}
};

const long long inf = 1e18;

int main()
{
	freopen("olympair.dat", "r", stdin);
	freopen("olympair.sol", "w", stdout);
	int n, m;
	//cin >> n >> m;
	scanf("%d%d", &n, &m);
	vector<map<int,long long> > vm;
	vm.resize(n);
	for (int i = 0, z, a, b, c; i < m; ++i)
	{
		scanf("%d%d%d%d", &z, &a, &b, &c);
		//cin >> z >> a >> b >> c;
		--a; --b;
		long long & wh = vm[a][b];
		if (z == 1)
		{
			if ((a != b) && (!wh || wh > c))
				wh = c;
		}
		else
		{
			for (map<int, long long>::const_iterator mi = vm[a].begin(); mi != vm[a].end(); ++mi)
			{
				int to = mi->first;
				if (mi->second == 0)
					break;
				long long h = mi->second + c;
				long long & wh = vm[b][to];
				if (!wh || wh > h)
					wh = h;
			}
		}
	}

	int s = 0;
	set<pp> d;
	vector<long long> dd(n, inf);
	dd[0] = 0;
	d.insert(pp(0, 0));
	//d[0] = 0;
	while (d.size())
	{
		s = d.begin()->wh;
		d.erase(d.begin());
		for (map<int, long long>::const_iterator mi = vm[s].begin(); mi != vm[s].end(); ++mi)
		{
			int to = mi->first;
			long long c = mi->second;
			if (dd[to] == inf)
			{
				dd[to] = dd[s] + c;
				d.insert(pp(to, dd[to]));
			}
			else if (dd[to] > dd[s] + c)
			{
				d.erase(d.find(pp(to, dd[to])));
				dd[to] = dd[s] + c;
				d.insert(pp(to, dd[to]));
			}
		}
	}
	for (int i = 1; i < n; ++i)
		if (dd[i] != inf)
			cout << dd[i] << endl;	
		else
			printf("-1\n");
	return 0;
}

