#include <iostream>
#include <fstream>
#include <vector>
#include <string>

#define task_name "olympair"

using namespace std;

struct line_t {
    int ver;
    int next;
    int time;
};

int vers[100001];
bool color[100001];
line_t lines[100001];

int get_time(int time,int from,int to) {
    int h = vers[from];
    int min_time = -1;
    color[from] = true;
    while(h != 0) {
        if(lines[h].ver == to) {
            color[from] = false;
            return lines[h].time;
        }
        int tmp = get_time(time+lines[h].time,lines[h].ver,to);
        if(min_time == -1 || tmp < min_time)
            min_time = tmp;
        h = lines[h].next;
    }
    color[from] = false;
    return min_time;
}

int main() {
	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    int h,line_head=0,n,m,type,a,b,c;
    inp >> n >> m;

    for(int i=0;i<m;i++) {
        inp >> type >> a >> b >> c;
        if(type == 1) {
            lines[line_head].ver = b;
            lines[line_head].next = vers[a];
            lines[line_head].time = c;
            vers[a] = line_head;
            line_head++;
        } else {
            h = vers[a];
            while(h != 0) {
                lines[line_head].ver = lines[h].ver;
                lines[line_head].next = vers[b];
                lines[line_head].time = lines[h].time + c;
                vers[b] = line_head;
                line_head++;
                h = lines[h].next;
            }
        }
    }

    for(int i=2;i<=n;i++) {
        out << get_time(0,1,i) << endl;
    }

	inp.close();
	out.close();
}
