#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define task_name "cap"

using namespace std;

struct point{
    int x;
    int y;
};

point start,finish;
bool matrix[1000][1000];
point q_list[10000];
int q_length[10000];
int head=1,tail=0;
int n,m;

int bfs() {
    while(head > tail) {
        if(q_list[tail].x == finish.x && q_list[tail].y == finish.y)
            return q_length[tail];
        q_list[head] = q_list[tail];
        q_list[head].x--;
        q_length[head] = q_length[tail]+1;
        head++;
        q_list[head] = q_list[tail];
        q_list[head].x++;
        q_length[head] = q_length[tail]+1;
        head++;
        q_list[head] = q_list[tail];
        q_list[head].y--;
        q_length[head] = q_length[tail]+1;
        head++;
        q_list[head] = q_list[tail];
        q_list[head].y++;
        q_length[head] = q_length[tail]+1;
        head++;
        tail++;
    }
    return -1;
}

int main() {

	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    char tmp;
    inp >> n >> m;

    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            inp >> tmp;
            if(tmp == '.')
                matrix[i][j] = false;
            if(tmp == 'x' || tmp == 'o' || tmp == '+')
                matrix[i][j] = true;
            if(tmp == 'o') {
                start.x = i;
                start.y = j;
            }
            if(tmp == '+') {
                finish.x = i;
                finish.y = j;
            }
        }
    }

    q_list[0] = start;
    q_length[0] = 1;
    out << bfs() << endl;

	inp.close();
	out.close();

}
