#include <iostream>
#include <fstream>
#include <string>
#include <algorithm>
#include <set>
#include <map>

#define task_name "cap"

using namespace std;

struct point{
    int x;
    int y;
};

point start,finish;
bool matrix[1001][1001];
point q_list[1000000];
int q_length[1000000];
int head=1,tail=0;
int n,m;

void add_list(int x, int y, int length) {
    q_list[head].x = x;
    q_list[head].y = y;
    matrix[x][y] = false;
    q_length[head] = length+1;
}

int bfs() {
    while(head > tail) {
        if(q_list[tail].x == finish.x || q_list[tail].y == finish.y)
            return q_length[tail]+1;
        int i=1;
        while(q_list[tail].x-i >= 0) {
            if(matrix[q_list[tail].x-i][q_list[tail].y]) {
                add_list(q_list[tail].x-i,q_list[tail].y,q_length[tail]);
                if(q_list[head].x == finish.x && q_list[head].y == finish.y) {
                    return q_length[head];
                }
                head++;
            }
            i++;
        }

        i=1;
        while(q_list[tail].x+i < n) {
            if(matrix[q_list[tail].x+i][q_list[tail].y]) {
                add_list(q_list[tail].x+i,q_list[tail].y,q_length[tail]);
                if(q_list[head].x == finish.x && q_list[head].y == finish.y) {
                    return q_length[head];
                }
                head++;
            }
            i++;
        }

        i=1;
        while(q_list[tail].y-i >= 0) {
            if(matrix[q_list[tail].x][q_list[tail].y-i]) {
                add_list(q_list[tail].x,q_list[tail].y-i,q_length[tail]);
                if(q_list[head].x == finish.x && q_list[head].y == finish.y) {
                    return q_length[head];
                }
                head++;
            }
            i++;
        }

        i=1;
        while(q_list[tail].y+i < m) {
            if(matrix[q_list[tail].x][q_list[tail].y+i]) {
                add_list(q_list[tail].x,q_list[tail].y+i,q_length[tail]);
                if(q_list[head].x == finish.x && q_list[head].y == finish.y) {
                    return q_length[head];
                }
                head++;
            }
            i++;
        }

        tail++;
    }
    return -1;
}

int main() {

	ifstream inp(task_name".dat");
	ofstream out(task_name".sol");

    char tmp;
    inp >> n >> m;

    for(int i=0;i<n;i++) {
        for(int j=0;j<m;j++) {
            inp >> tmp;
            if(tmp == '.')
                matrix[i][j] = false;
            if(tmp == 'x' || tmp == 'o' || tmp == '+')
                matrix[i][j] = true;
            if(tmp == 'o') {
                start.x = i;
                start.y = j;
            }
            if(tmp == '+') {
                finish.x = i;
                finish.y = j;
            }
        }
    }

    q_list[0].x = start.x;
    q_list[0].y = start.y;
    q_length[0] = 0;
    out << bfs() << endl;


	inp.close();
	out.close();

}
