#include <fstream>
#include <vector>
#include <climits>

using namespace std;

ifstream fin("cap.dat");
ofstream fout("cap.sol");

int n;
int m;

bool available[1000][1000];
int stepsNum[1000][1000];

int startX;
int startY;

int targetX;
int targetY;

vector <int> x;
vector <int> y;

int counter;

void init()
{
    fin >> n >> m;

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            stepsNum[i][j] = INT_MAX;
        }
    }

    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < m; j++)
        {
            char ch; fin >> ch;

            switch(ch)
            {
                case 'x':
                    available[i][j] = true;
                    break;
                case '.':
                    available[i][j] = false;
                    break;
                case 'o':
                    available[i][j] = true;
                    stepsNum[i][j] = 0;
                    startX = j;
                    startY = i;
                    x.push_back(j);
                    y.push_back(i);
                    break;
                case '+':
                    available[i][j] = true;
                    targetX = j;
                    targetY = i;
            }
        }
    }

    counter = 1;
}

int main(void)
{
    init();

    while(true)
    {
        if(x.size() == 0 && y.size() == 0)
        {
            fout << -1 << '\n';
            return 0;
        }

        vector <int> newX;
        vector <int> newY;

        for(int i = 0; i < x.size() && i < y.size(); i++)
        {
            for(int j = 0; j < n; j++)
            {
                if(available[j][x.at(i)] && counter < stepsNum[j][x.at(i)])
                {
                    if(x.at(i) == targetX && j == targetY)
                    {
                        fout << counter << '\n';
                        return 0;
                    }

                    stepsNum[j][x.at(i)] = counter;
                    newX.push_back(x.at(i));
                    newY.push_back(j);
                }
            }

            for(int j = 0; j < m; j++)
            {
                if(available[y.at(i)][j] && counter < stepsNum[y.at(i)][j])
                {
                    if(j == targetX && y.at(i) == targetY)
                    {
                        fout << counter << '\n';
                        return 0;
                    }

                    stepsNum[y.at(i)][j] = counter;
                    newX.push_back(j);
                    newY.push_back(y.at(i));
                }
            }
        }

        x = newX;
        y = newY;

        counter++;
    }

    return 0;
}
