program olympair;

type reb = record
  v, n, c: longint;
end;

const inf = 1000000000;
      q_size = 10000000;

var i, n, m, a, b, c, tip, zn: longint;
    st, dist: array[1..100000] of longint;
    list: array[1..q_size] of reb;
    q: array[1..q_size] of longint;
    used: array[1..100000] of boolean;

procedure add(a, b, c: longint);
  begin
    inc(zn);
    list[zn].v := b;
    list[zn].c := c;
    list[zn].n := st[a];
    st[a] := zn;
  end;

procedure madd(a, b, c: longint);
  var i: longint;
  begin
    i := st[a];
    while i <> 0 do
      begin
        add(b, list[i].v, list[i].c + c);
        i := list[i].n;
      end;
  end;

procedure calc_dist;
  var i, head, tail: longint;
  begin
    head := 1; tail := 2;
    q[1] := 1;
    fillchar(used, sizeof(used), false);
    used[1] := true;
    while head <> tail do
      begin
        i := st[q[head]];
        while i <> 0 do
          begin
            if dist[q[head]] + list[i].c < dist[list[i].v] then
              begin
                dist[list[i].v] := dist[q[head]] + list[i].c;
                if not used[list[i].v] then
                  begin
                    used[list[i].v] := true;
                    q[tail] := list[i].v;
                    tail := (tail mod (q_size - 1)) + 1;
                  end;
              end;
            i := list[i].n;
          end;
        used[q[head]] := false;
        head := (head mod (q_size - 1)) + 1;
      end;
  end;

begin
  assign(input, 'olympair.dat');
  assign(output, 'olympair.sol');
  reset(input); rewrite(output);
  fillchar(st, sizeof(st), 0);
  read(n, m);
  zn := 0;
  for i := 1 to m do
    begin
      read(tip, a, b, c);
      if tip = 1 then add(a, b, c) else
        madd(a, b, c);
    end;
  for i := 1 to n do dist[i] := inf;
  dist[1] := 0;
  calc_dist;
  for i := 2 to n do
    if dist[i] = inf then writeln(-1) else writeln(dist[i]);
  close(input); close(output);
end.