#include <cstdio>
#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <list>
#include <queue>
#include <deque>
#include <string>
#include <cstring>

using namespace std;

#if (_WIN32 || __WIN32__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

typedef long long INT;

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}
#define pu push_back

#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))
#define Abs(a) ((a)>0?(a):-(a))

const int MAXN = 200010;

struct edge{
    int to, val;
    edge (int _to = 0, int _val = 0) : to(_to), val(_val) {}
};

bool operator<(edge a, edge b){
    return a.val < b.val || (a.val == b.val && a.to < b.to);
}

list<edge> g[MAXN];
INT d[MAXN];
int n;

int main(){
    WITH_FILES(olympair.dat, olympair.sol)
    int tststs;
    scanf("%d%d", &n, &tststs);
    while (tststs--){
        int inp;
        scanf("%d" ,&inp);
        if (inp == 1){
            int x, y, val;
            scanf("%d%d%d", &x, &y, &val);
            x--; y--;
            g[x].pu(edge(y, val));
        }
        else{
            int a, b, c;
            scanf("%d%d%d", &a, &b, &c);
            a--; b--;
            for (list<edge>::iterator it = g[a].begin(); it != g[a].end(); it++)
                g[b].pu(edge(it->to, it->val + c));
        }
    }
    /*for (int i = 0; i < n; i++, printf("\n")){
        for (int j = 0; j < (int)g[i].size(); j++)
            printf("(%d %d) ", g[i][j].to, g[i][j].val);
    }*/
    set<edge> q;
    for (int i = 1; i < n; i++)
        d[i] = -1;
    q.insert(edge(0, 0));
    while (!q.empty()){
        int v = q.begin()->to;
        int dist = q.begin()->val;
        q.erase(q.begin());
        for (list<edge>::iterator it = g[v].begin(); it != g[v].end(); it++){
            int to = it->to;
            int val = it->val;
            if (d[to] == -1 || d[to] > dist + val){
                q.erase(edge(to, d[to]));
                d[to] = dist + val;
                q.insert(edge(to, d[to]));
            }
        }
    }
    for (int i = 1; i < n; i++)
        printf(LLD"\n", d[i]);
    return 0;
}

