#include <iostream>
#include <cstdio>
#include <cmath>
#include <cstring>
#include <string>
#include <vector>
#include <list>
#include <set>
#include <map>
#include <queue>
#include <deque>
#include <cstdlib>
#include <bitset>
#include <algorithm>

using namespace std;

typedef long long INT;

#if (_WIN32 || __WIN32|__)
    #define LLD "%I64d"
#else
    #define LLD "%lld"
#endif

#define INPUT(a) freopen(#a, "r", stdin);
#define OUTPUT(a) freopen(#a, "w", stdout);
#define WITH_FILES(a, b) {INPUT(a) OUTPUT(b)}
#define pu push_back

#define debug(x) cerr << #x << " = " << (x) << endl;

#define Max(a, b) ((a)>(b)?(a):(b))
#define Min(a, b) ((a)<(b)?(a):(b))

const int MAXN = 35010;

struct circle{
    int x, y, r, cost;
    circle (int _x = 0, int _y = 0, int _r = 0, int _cost = 0) : x(_x), y(_y), r(_r), cost(_cost) {}
};

bool operator<(circle a, circle b){
    return a.cost < b.cost || (a.cost == b.cost && a.x < b.x || (a.x < b.x && a.y < b.y));
}

struct knight{
    int x, y, l;
    knight (int _x = 0, int _y = 0, int _l = 0) : x(_x), y(_y), l(_l) {}
};

bool operator<(knight a, knight b){
    return a.x < b.x || (a.x == b.x && a.y < b.y);
}

list<int> g[MAXN];
circle c[MAXN];
knight a[MAXN];
int n, m, k;
int p[MAXN];
int f[MAXN];

inline INT d2(int x1, int y1, int x2, int y2){
    return 1ll * (x1 - x2) * (x1 - x2) + 1ll * (y1 - y2) * (y1 - y2);
}

int main(){
    WITH_FILES(camelot.dat, camelot.sol)
    scanf("%d%d%d", &n, &m, &k);
    for (int i = 0; i < n; i++)
        scanf("%d%d%d%d", &c[i].x, &c[i].y, &c[i].r, &c[i].cost);
    for (int i = 0; i < m; i++)
        scanf("%d%d%d", &a[i].x, &a[i].y, &a[i].l);
    printf("0\n");
    return 0;
}
