#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

typedef long long LL;

FILE *fin = fopen( "olympair.dat", "r" );
FILE *fout = fopen( "olympair.sol", "w" );

//const int MAXN = int(1e5)+42;
const int MAXN = 2042;
const LL INF = 1LL<<60;

LL g[MAXN][MAXN];
bool way[MAXN][MAXN];

bool used[MAXN];
LL time_to[MAXN];

void add ( int from, int to, LL time ){
    if ( way[from][to] ) {
        g[from][to] = min ( g[from][to], time );
    } else {
        g[from][to] = time;
		way[from][to] = true;
    }
}

int main(){
    int n, m;
    fscanf( fin, "%d %d\n", &n, &m );

    for ( int i = 0; i < n; ++i ){
        memset( way[i], false, sizeof ( bool ) * n );
    }

    for ( int i = 0; i < m; ++i ) {
        int type, a, b;
        LL c;
        fscanf ( fin, "%d %d %d %Ld\n", &type, &a, &b, &c );
        --a; --b;
        if ( type == 1 ){
            add(a,b,c);
        }else{
            for ( int i = 0; i < n; ++i ) {
                if ( way[a][i] ){
                    add ( b, i, g[a][i]+c );
                }
            }
        }
    }

    memset ( used, false, sizeof ( bool ) * n );
    set < pair < LL, int > > q;
    time_to[0] = 0;
    used[0] = true;
    q.insert(make_pair(time_to[0], 0));
    while ( !q.empty() ){
        pair < LL, int > current = *q.begin();
        q.erase(q.begin());
        LL current_time = current.first;
        LL current_heap = current.second;
        for ( int i = 0; i < n; ++i ) {
            if ( way[current_heap][i] ) {
                if ( !used[i] ) {
                    time_to[i] = current_time + g[current_heap][i];
                    q.insert(make_pair ( time_to[i], i ));
                    used[i] = true;
                }
                if ( current_time + g[current_heap][i] < time_to[i] ) {
                    q.erase(make_pair ( time_to[i], i ));
                    time_to[i] = current_time + g[current_heap][i];
                    q.insert(make_pair ( time_to[i], i ));
                }
            }
        }
    }

    for ( int i = 1; i < n; ++i ) {
        fprintf( fout, "%Ld\n", ((used[i])?time_to[i]:-1) );
    }
    fclose ( fout );

    return 0;
}

