#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <utility>
#include <algorithm>

using namespace std;

typedef long long LL;

const LL INF = 1LL<<62;

FILE *fh;
vector < list < pair < int, LL > > > g;
vector < LL > time_to;

void add ( int a, int b, LL c ) {
	g[a].push_back(make_pair ( b, c ));
}

int main(){
	fh = fopen ( "olympair.dat", "r" );
	int n, m;
	fscanf ( fh, "%d %d\n", &n, &m );
	g.resize(n);
	/*for ( int i = 0; i < n; ++i );*/

	for ( int i = 0; i < m; ++i ) {
		int a, b, type;
		LL c;
		fscanf ( fh, "%d %d %d %Ld\n", &type, &a, &b, &c );
		--a; --b;
		if ( type == 1 ) {
			add ( a, b, c );
		}else {
			for ( list < pair < int, LL > > :: iterator it = g[a].begin(); it != g[a].end(); ++it ) {
				add ( b, it->first, it->second+c );
			}
		}
	}

	time_to.resize ( n, INF );

	set < pair < LL, int > > q;
	time_to[0] = 0;
	q.insert ( make_pair ( time_to[0], 0 ) );
	while ( !q.empty() ) {
		int heap = q.begin()->second;
		q.erase(q.begin());
		LL time = time_to[heap];
		for ( list < pair < int, LL > > :: iterator it = g[heap].begin(); it != g[heap].end(); ++it ) {
			if ( time_to[it->first] > time+it->second ) {
				q.erase(make_pair(time_to[it->first], it->first));
				time_to[it->first] = time+it->second;
				q.insert(make_pair(time_to[it->first], it->first));
			}
		}
	}	
	fh = fopen ( "olympair.sol", "w" );
	for ( int i = 1; i < n; ++i ) {
		fprintf ( fh, "%Ld\n", (time_to[i]==INF)?-1:time_to[i]  );
	}
	fclose ( fh );
	return 0;
}