#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

ifstream fin("tetris.dat");
ofstream fout("tetris.sol");
typedef long long LL;
/*typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
template < typename T > const T sqr(const T x){return x*x;}
const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}*/
vector < char > end_config;

inline void out(const LL cnt){
    fout << cnt;
    exit(0);
}
int n;
const bool operator < ( const vector < char > &a, const vector < char > &b ){
    int a_cnt = 0, b_cnt = 0;
    for ( int i = 0; i < n; ++i ){
        a_cnt += (4+a[i]-end_config[i])%4;
        b_cnt += (4+b[i]-end_config[i])%4;
    }
    return a_cnt < b_cnt;
}

int main(){
    fin >> n;
    vector < char > begin_config(n), difference(n);
    for ( int i = 0; i < n; ++i ){
        int curr;
        fin >> curr;
        begin_config[i] = (char)curr;
    }
    end_config.resize(n);
    for ( int i = 0; i < n; ++i ){
        int curr;
        fin >> curr;
        end_config[i] = (char)curr;
        difference[i] = (4+end_config[i]-begin_config[i])%4;
    }
    bool flag = true;
    LL cnt = 0;
    while ( flag ){
        int i = 0;
        for ( i = 0; i < n && difference[i] == 0; ++i );
        if ( i == n ) break;
        ++cnt;
        char min_dif = difference[i], j;
        for ( j = i+1; j < n && difference[j]; ++j ){
            min_dif = min ( min_dif, difference[j] );
        }
        for ( int k = i; k < j; ++k ){
            begin_config[k] = (begin_config[k]+1)%4;
        }
        char min_height = 4;
        for ( int k = 0; k < n; ++k ){
            min_height = min ( begin_config[k], min_height );
        }
        for ( int k = 0; k < n; ++k ){
            begin_config[k] -= min_height;
            difference[k] = (4+end_config[k]-begin_config[k])%4;
        }
    }
    fout << cnt << endl;

    return 0;
}
