#include <cstdio>
#include <cmath>
#include <cstdlib>
#include <cstring>
#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <utility>

using namespace std;

ifstream fin("camelot.dat");
ofstream fout("camelot.sol");
typedef long long LL;
typedef long double LD;
const LD PI = 3.1415926535897932384626433832795L;
const LL INF = 1LL << 60;
template < typename T > const T sqr(const T x){return x*x;}
//const LL binpow(const LL a, const LL n, const LL mod){if ( n == 0 ) return 1;if ( n == 1 ) return a%mod;return (binpow( sqr(a), n/2, mod ) * ( n % 2 ? a : 1 ))%mod;}

class tower{
public:
    int x, y, radius;
    int tax;
    tower(int _x, int _y, int r, int _t ): x(_x), y(_y), radius(r), tax(_t){}
    tower(){}
};
class knight {
public:
    int x, y;
    int l;
    knight(){}
    knight(int _x, int _y, int _l):x(_x),y(_y),l(_l) {}
};
istream& operator >> (istream &in, tower &t){
    in >> t.x >> t.y >> t.radius >> t.tax;
    return in;
}
istream& operator >> (istream &in, knight &t){
    in >> t.x >> t.y >> t.l;
    return in;
}
int n, m, k;
vector < tower > towers;
vector < knight > knights;
vector < list < pair < int, int > > > g;

bool knight_in_tower( knight k, tower t){
    return sqr(k.x-t.x)+sqr(k.y-t.y) <= sqr(t.radius);
}

vector < vector < LL > > dist;
void add (int a, int b, int c){
    /*g[a].push_back(make_pair(b,c));
    g[b].push_back(make_pair(a,c));*/
    dist[a][b] = c;
    dist[b][a] = c;
}

vector < LL > pay_for_tower;
int main(){
    fin >> n >> m >> k;
    towers.resize(n+1);
    knights.resize(m);
    for ( int i = 1; i <= n; ++i ){
        fin >> towers[i];
    }
    for ( int i = 0; i < m; ++i ){
        fin >> knights[i];
    }
    g.resize(n+1);
    dist.resize(n+1,vector<LL>(n+1, INF));
    for ( int i = 1; i <= n; ++i ){
        add(0,i,towers[i].tax+0);
        for ( int j = i+1; j <= n; ++j){
            add ( i, j, towers[i].tax+towers[j].tax );
        }
    }

    for ( int i = 0; i <= n; ++i ) dist[i][i] = 0;
    for ( int i = 0; i <= n; ++i ){
        for ( int j = 0; j <= n; ++j ){
            for ( int k = 0; k <= n; ++k ){
                dist[i][j] = min (dist[i][j], dist[i][k]+dist[k][j]);
            }
            dist[j][i] = dist[i][j];
        }
    }

    pay_for_tower.resize(n+1,0);
    for ( int i = 0; i < m; ++i ) {
        bool flag = false;
        for ( int j = 1; j <= n; ++j ){
            if (knight_in_tower(knights[i], towers[j])){
                flag = true;
                for ( int k = 0; k <= n; ++k ){
                    pay_for_tower[k] += knights[i].l*dist[j][k];
                }
            }
        }
        if ( !flag ){
            for ( int k = 0; k <= n; ++k ){
                pay_for_tower[k] += knights[i].l*dist[0][k];
            }
        }
    }

    LL min_pay = pay_for_tower[0];
    for ( int i = 1; i <= n; ++ i ){
        min_pay = min ( min_pay, pay_for_tower[i] );
    }
    fout << min_pay << endl;
    return 0;
}
