#include<cstdio>
#include<set>

#define pb push_back

using namespace std;

typedef long long ll;

const int maxn = 100011;
const ll INF = 2*1e18+1;
const int inf = 1e9;

struct _edge{
	int fr, to;
	ll cost;
};

bool operator< (_edge a, _edge b){
	return (a.fr < b.fr) || (a.fr == b.fr && a.to < b.to);
}

bool operator== (_edge a, _edge b){
	return a.fr == b.fr && a.to == b.to;
}

int n,m;
_edge t, out;
ll D[maxn];
_edge K[maxn];
int kl;
set<_edge> S;
set<_edge> :: iterator it;

void go(int a, int b, ll c){
	t.fr = a;
	t.to = b;
	t.cost = c;
	it = S.find(t);
	if(it == S.end()){
		S.insert(t);
	}
	else{
		if(it->cost > c){
			S.erase(it);
			S.insert(t);
		}
	}
}

int main(){	
	freopen("olympair.dat","r",stdin);
	freopen("olympair.sol","w",stdout);
	scanf("%d%d",&n,&m);
	int t,a,b,x;
	ll c;
	for(int i=1;i<=n;i++)
		D[i]=INF;
	for(int i=1; i<=m; i++){
		scanf("%d%d%d%lld",&t,&a,&b,&c); //lld!
		if(t == 2){
			x=a; a=b; b=x;
		}
		//printf("go(%d %d %I64d)\n", a,b,c);
		go(a,b,c);
	}
	for(it = S.begin(); it!=S.end(); it++){
		K[++kl] = *it;
	}
	//for(int i=1;i<=kl; i++) printf("%d %d %I64d\n", K[i].fr, K[i].to, K[i].cost);
	bool any = true;
	int cfr, cto;
	ll ccost;
	D[1] = 0;
	while(any){
		//printf("and again...\n");
		any = false;
		for(int i=1; i<=kl; i++){
			cfr = K[i].fr; cto = K[i].to; ccost = K[i].cost;
			//printf("D[%d] + %I64d < D[%d] ----- %I64d + %I64d < %I64d\n", cfr, ccost, cto, D[cfr], ccost,D[cto]);
			if(D[cfr] + ccost < D[cto]){
				any = true;
				D[cto] = D[cfr] + ccost;
			}
		}
	}
	for(int i=2;i<=n; i++){
		if(D[i]>=INF) printf("-1\n");
		else printf("%lld\n", D[i]);
	}
	return 0;
}
