#include<cstdio>
#include<cmath>
#include<algorithm>
#include<list>
#include<set>

#define pb push_back

#define Min(a,b) (a)<(b)?(a):(b)

using namespace std;

typedef long long ll;

const int maxn = 35011;
const ll INF=1e18;

struct _fort{
	int x, y, r, c, hm, par;
	list<int> child;
	int pr;
	ll cost;
	int id;
};
bool operator<(_fort a, _fort b){
	if(a.r != b.r) return a.r < b.r;
	return (a.x<b.x) || (a.x==b.x && a.y<b.y);
}

struct _knight{
	int x, y, am;
};

list<int>::iterator it;
int n, m, k;
int hm[maxn];
_fort F[maxn];
_knight K[maxn];
bool vis[maxn];

bool rvs(_fort a, _fort b){
	return a.cost>b.cost || (a.cost == b.cost && a.id<b.id);
}

bool inside(_fort a, _fort b){
	if( (a.r+b.r)*(a.r+b.r) > (a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y) )
		return true;
	return false;
}

bool in(_knight k, _fort f){
	//printf("[%d %d] [%d %d] (%d)\n", k.x, k.y, f.x, f.y, f.r);
	ll d = ((ll)k.x-f.x)*(k.x-f.x) + ((ll)k.y-f.y)*(k.y-f.y);
	if(d < (ll)f.r*f.r) {
		//printf("+\n");
		return true;
	}
	//printf("false\n");
	return false;
}

ll _min(ll a, ll b){
	if(a>b) a=b;
	return a;
}

int find_id(int a){
	for(int i=1; i<=n; i++)
		if(F[i].id==a) return i;
	return 0;
}

void clr(){
	for(int i=1;i<=n;i++)
		vis[i] = false;
}

struct cdfs{
	int am;
	ll cost;
};

cdfs dfs(int v, bool frp, int alr){
	if(frp==0){
	//printf("dfs(%d)\n",v);
	cdfs ret, out;
	ret.am = ret.cost = 0;
	vis[v] = false;
	if(!F[v].child.empty())for(it=F[v].child.begin(); it!=F[v].child.end(); it++){
		if(!vis[*it]){
			out=dfs(*it,0,0);
			ret.cost += out.cost;
			ret.am += out.am;
		}
	}
	ret.am += F[v].hm;
	ret.cost += ret.am*F[v].c;
	return ret;
	}
	else{
		cdfs ret, up, down;
		ret.am = ret.cost = up.am = up.cost = 0;
		if(F[v].par!=0){
			up = dfs(F[v].par, 1, F[v].c);
		}
		down = dfs(v, 0,0);
		ret.cost = down.cost + up.cost + (down.am + up.am)*alr;
		return ret;
	}
}

int main(){
	freopen("camelot.dat","r",stdin);
	freopen("camelot.sol","w",stdout);
	scanf("%d%d%d", &n, &m, &k);
	for(int i=1;i<=n;i++){
		scanf("%d%d%d%d", &F[i].x, &F[i].y, &F[i].r, &F[i].c);
		F[i].id=i;
	}
	for(int i=1;i<=m;i++){
		scanf("%d%d%d", &K[i].x, &K[i].y, &K[i].am);
	}
	if(k!=0){bool any;
	for(int i=1;i<=m;i++){
		any = false;
		for(int j=1; j<=n; j++)
			if(in(K[i],F[j])){
				F[j].hm += K[i].am;
				any = true;
				break;
			}
		if(any == false){
			F[0].hm += K[i].am;
		}
	}
	int sum=0;//total men
	for(int i=1; i<=n; i++)
		F[i].cost = (ll)F[i].hm*F[i].c;
	for(int i=0; i<=n; i++) {
		sum += F[i].hm;
		//printf("cost in %d castle : %d*%d\n", i,hm[i], F[i].c);
	}
	sort(F+1, F+1+m,rvs);
	for(int i=0; i<=n; i++) {
		//printf("cost in %d castle : %d*%d -- %I64d\n", i,F[i].hm, F[i].c, F[i].cost);
	}
	F[0].cost = 0;
	int bc;
	ll cmin =0, cnt;
	for(int i=k+1; i<=n; i++)
		cmin+=F[i].cost;
	//printf("now %I64d\n",cmin);
	//printf("total population %d\n", sum);
	bool was;
	for(int i=1; i<=n;i++){
		//printf("hostedby %d\n",i);
		cnt = 0;
		for(int i=k; i<=n; i++)
			cnt += F[i].cost;
		cmin = _min(cmin,cnt);
		//printf("now %I64d\n",cmin);
		cnt = (sum - F[i].hm)*F[i].c;
		was = false;
		for(int j=k+1; j<=n; j++)
			if(i!=j)
				cnt += F[j].cost;
			else was = true;
		if(was == true)
			cnt -= F[k].cost;
		cmin = _min(cmin,cnt);
		//printf("now %I64d\n",cmin);
	}
	printf("%lld\n",cmin);
	}
	else{//k==0
		cdfs out;
		ll cmin=0,cnt;
		bool any;
		sort(F+1, F+1+n);
		//for(int i=1;i<=n;i++) printf("%d %d %d %d\n",F[i].x, F[i].y,F[i].r,F[i].c);
		for(int j=1; j<=m; j++){
			any = false;
			for(int i=1; i<=n; i++)
				if(in(K[j], F[i])){
					F[i].hm += K[j].am;
					any = true;
					break;
				}
				if(!any) F[0].hm += K[j].am;
		}
		for(int i=1;i<=n; i++)
			for(int j=i+1;j<=n;j++)
				if(inside(F[i],F[j])){
					F[i].par=j;
					F[j].child.pb(i);
				}

		for(int i=n;i>=1;i--){
			if(F[i].par==0)
				F[i].pr = F[i].c;
			else
				F[i].pr = F[i].c + F[ F[i].par ].pr;
		}

		/*for(int i=0;i<=n;i++) {
			printf("%d %d %d %d %d, par = %d, childs = ",F[i].x, F[i].y,F[i].r,F[i].c, F[i].hm, F[i].par);
			for(it = F[i].child.begin(); it!=F[i].child.end(); it++)
				printf("%d ", *it);
			printf("\n");
			printf("price in = %d\n", F[i].pr);
		}*/
		cmin = INF;
		for(int i=1; i<=n; i++){
			clr();
			//printf("hostedby %d\n",i);
			out = dfs(i,0,0);
			cnt = 0;
			cnt += out.cost;
			//printf("%I64d\n", out.cost);
			out = dfs(F[i].par, 1, F[i].c); //?
			//printf("%I64d\n", out.cost);
			cnt += out.cost;
			for(int j=1;j<=n;j++)
				if(!vis[j])
					cnt += (F[j].pr + F[i].pr) * F[j].hm;
			cmin = min(cmin, cnt);
		}
			printf("%I64d\n", cmin);
	}
	return 0;
}
