#include <fstream>
#include <vector>
#include <list>
#include <set>

const int infinity = 1000*1000*1000;

bool check(const std::list<int>& genom)
{
	std::set<int> used;
	for(std::list<int>::const_iterator i = genom.begin();i != genom.end();i++)
	{
		if(used.find(*i) == used.end())
			used.insert(*i);
		else
			if(*--std::list<int>::const_iterator(i) != *i)
				return false;
	}
	return true;
}

int through(const std::list<int>& current,std::set<int>& gen)
{
	if(check(current))
		return 0;
	int answer = infinity;
	for(std::set<int>::const_iterator i = gen.begin();i != gen.end();i++)
	{
		std::list<int> temp = current;
		gen.erase(*i);
		for(std::list<int>::iterator j = temp.begin();j != temp.end();)
		{
			if(*j != *i)
				j++;
			else
				j = temp.erase(j);
		}
		answer = std::min(answer,through(temp,gen) + 1);
		gen.insert(*i);
	}
	return answer;
}

int main()
{
	std::ifstream in("mutation.dat");//fix
	int n;
	in >> n;
	std::list<int> genom;
	std::set<int> gen;
	for(int i = 0;i < n;i++)
	{
		int temp;
		in >> temp;
		genom.push_back(temp);
		gen.insert(temp);
	}
	in.close();
	std::ofstream out("mutation.sol");
	out << through(genom,gen) << std::endl;
	out.close();
}
