#include <fstream>
#include <vector>
#include <queue>
#include <list>

const int infinity = 1000*1000*1000;

const char startTag = 'o';
const char finishTag = '+';
const char emptyTag = '.';

void dfs(const std::vector<std::vector<char> >& field,std::vector<std::vector<bool> >& used,
		 std::pair<int,int> current,std::vector<std::vector<int> >& distance)
{
	int x = current.first;
	int y = current.second;
	if(used[x][y] || field[x][y] == emptyTag)
		return;
	used[x][y] = true;
	for(int i = 0;i < field[x].size();i++)
	{
		dfs(field,used,std::make_pair(x,i),distance);
		distance[x][i] = std::min(distance[x][i],distance[x][y] + 1);
	}
	for(int i = 0;i < field.size();i++)
	{
		dfs(field,used,std::make_pair(i,y),distance);
		distance[i][y] = std::min(distance[i][y],distance[x][y] + 1);
	}
}

int main()
{
	std::ifstream in("cap.dat"); // fix
	int n,m;
	in >> n >> m;
	std::vector<std::vector<char> > field(n,std::vector<char>(m));
	std::vector<std::vector<bool> > used(n,std::vector<bool>(m));
	std::pair<int,int> start,finish;
	for(int i = 0;i < field.size();i++)
	{
		for(int j = 0;j < field[i].size();j++)
		{
			in >> field[i][j];
			if(field[i][j] == startTag)
				start = std::make_pair(i,j);
			if(field[i][j] == finishTag)
				finish = std::make_pair(i,j);
		}
	}
	in.close();
	std::vector<std::vector<int> > distance(n,std::vector<int>(m,infinity));
//	std::queue<std::pair<int,int>,std::list<std::pair<int,int> > > queue;
//	queue.push(start);
	distance[start.first][start.second] = 0;
	dfs(field,used,start,distance);
/*	while(!queue.empty())
	{
		int x = queue.front().first;
		int y = queue.front().second;
		queue.pop();
		if(used[x][y] || field[x][y] == emptyTag)
			continue;
		used[x][y] = true;
		if(field[x][y] == finishTag)
			break;
		for(int i = 0;i < field[x].size();i++)
		{
			queue.push(std::make_pair(x,i));
			distance[x][i] = std::min(distance[x][i],distance[x][y] + 1);
		}
		for(int i = 0;i < field.size();i++)
		{
			queue.push(std::make_pair(i,y));
			distance[i][y] = std::min(distance[i][y],distance[x][y] + 1);
		}
	}*/
	std::ofstream out("cap.sol");
	out << (distance[finish.first][finish.second] != infinity ? distance[finish.first][finish.second] : -1) << std::endl;
	out.close();
}