#include <cstdio>
#include <iostream>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

typedef long long ll;
#define min(a,b) (( (a)<(b) )?(a):(b))
#define max(a,b) (((a)>(b))?(a):(b))
#define abs(a) (((a)<0)?-(a):(a))

using namespace std;

vector<int> g[36000];
int p[36000];

int n, m, k;
struct okr
{
	int x, y, r, c;
} os[36000], men[36000];
int wh[36000];

bool cmp(okr a, okr b)
{
	return a.r < b.r;
}

bool inside(okr a, okr out)
{
	return (ll)(a.x-out.x)*(ll)(a.x-out.x)+(ll)(a.y-out.y)*(ll)(a.y-out.y) <= (ll)(a.r-out.r)*(ll)(a.r-out.r);
}

ll cst[1001][1001];
int tv;

void dfs(int v, int cost)
{
	cst[tv][v] = cost;
	int sz = g[v].size();
	for (int i = 0; i < sz; i++)
	{
		int to = g[v][i];
		if (cst[tv][to] != -1)
			continue;
		dfs(to, cost + os[to].c);
	}
	if (cst[tv][p[v]] == -1 && p[v] != -1)
		dfs(p[v], cost + os[v].c);
}

int main()
{
	freopen("camelot.dat", "r", stdin);
	freopen("camelot.sol", "w", stdout);

	scanf("%d%d%d", &n, &m, &k);
	for (int i = 0; i < n; i++)
		scanf("%d%d%d%d", &os[i].x, &os[i].y, &os[i].r, &os[i].c), p[i] = -1;

	for (int i = 0; i < m; i++)
	{
		scanf("%d%d%d", &men[i].x, &men[i].y, &men[i].c);
		men[i].r = 0;
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			cst[i][j] = -1;
	
	sort(os, os + n, cmp);

	for (int i = 0; i < n; i++)
	{
		for (int j = i + 1; j < n; j++)
		{
			if (inside(os[i],os[j]))
			{
				p[i] = j;
				break;
			}
		}
	}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < m; j++)
			if (inside(men[j], os[i]))
			{
				wh[j] = i;
				break;
			}

	for (int i = 0; i < n; i++)
		for (int j = 0; j < n; j++)
			if (p[i] == j)
				g[j].push_back(i);

	for (tv = 0; tv < n; tv++)
		dfs(tv, 0);

	int res[36000];
	ll rr, best = 2000000000000000ll;
	for (int i = 0; i < n; i++)
	{
		rr = 0;
		for (int j = 0; j < m; j++)
			rr += (ll)men[i].c * cst[wh[j]][i];
		if (best > rr)
			best = rr;
	}

	cout << best;

	return 0;
}
